unofficial mirror of guix-patches@gnu.org 
 help / color / mirror / code / Atom feed
From: Vincent Legoll <vincent.legoll@gmail.com>
To: 40601@debbugs.gnu.org
Cc: Vincent Legoll <vincent.legoll@gmail.com>
Subject: [bug#40601] [PATCH 12/28] guix-install.sh: Rework user & group handling, adding busybox support.
Date: Sun, 17 May 2020 19:17:09 +0200	[thread overview]
Message-ID: <20200517171725.732-12-vincent.legoll@gmail.com> (raw)
In-Reply-To: <20200517171725.732-1-vincent.legoll@gmail.com>

* etc/guix-install.sh (REQUIRE): Remove groupadd, add comment.
(sys_create_build_user): Add adduser handling.
(sys_create_build_group): New function, add addgroup handling...
(main): ...call it here.
---
 etc/guix-install.sh | 57 +++++++++++++++++++++++++++++++++------------
 1 file changed, 42 insertions(+), 15 deletions(-)

diff --git a/etc/guix-install.sh b/etc/guix-install.sh
index 043357d9c4..d6966f851a 100755
--- a/etc/guix-install.sh
+++ b/etc/guix-install.sh
@@ -32,6 +32,8 @@ set -e
 
 [ "$UID" -eq 0 ] || { echo "This script must be run as root."; exit 1; }
 
+# groupadd, useradd, usermod, adduser, addgroup are handled in:
+# sys_create_build_user & sys_create_build_group functions.
 REQUIRE=(
     "wget"
     "gpg"
@@ -45,7 +47,6 @@ REQUIRE=(
     "rm"
     "chmod"
     "uname"
-    "groupadd"
     "tail"
     "realpath"
     "tar"
@@ -298,31 +299,56 @@ sys_create_store()
     _msg "${PAS}activated root profile at ${ROOT_HOME}/.config/guix/current"
 }
 
-sys_create_build_user()
-{ # Create the group and user accounts for build users.
+sys_create_build_group()
+{ # Create the group for build users.
 
     _debug "--- [ $FUNCNAME ] ---"
 
     if getent group guixbuild >/dev/null 2>&1; then
-        _msg "${INF}group guixbuild exists"
-    else
+        _msg "${INF}group guixbuild already exists"
+    elif command -v groupadd &>/dev/null; then
         groupadd --system guixbuild
         _msg "${PAS}group <guixbuild> created"
+    elif command -v addgroup &>/dev/null; then
+        addgroup -S guixbuild
+        _msg "${PAS}group <guixbuild> created"
+    else
+        _err "${ERR}cannot add group for guix build users"
+        exit 1
     fi
+}
+
+sys_create_build_user()
+{ # Create the user accounts for build users.
+
+    _debug "--- [ $FUNCNAME ] ---"
 
     for i in $(seq -w 1 10); do
         if getent passwd "guixbuilder${i}" >/dev/null 2>&1; then
-            _msg "${INF}user is already in the system, reset"
-            usermod -g guixbuild -G guixbuild           \
-                    -d /var/empty -s "$(which nologin)" \
-                    -c "Guix build user $i"             \
-                    "guixbuilder${i}";
+            if command -v usermod &>/dev/null; then
+                _msg "${INF}user is already in the system, resetting"
+                usermod -g guixbuild -G guixbuild           \
+                        -d /var/empty -s "$(which nologin)" \
+                        -c "Guix build user $i"             \
+                        "guixbuilder${i}"
+            else
+                _msg "${ERR}cannot reset user environment, doing nothing"
+            fi
         else
-            useradd -g guixbuild -G guixbuild           \
-                    -d /var/empty -s "$(which nologin)" \
-                    -c "Guix build user $i" --system    \
-                    "guixbuilder${i}";
-            _msg "${PAS}user added <guixbuilder${i}>"
+            if command -v useradd &>/dev/null; then
+                useradd -g guixbuild -G guixbuild           \
+                        -d /var/empty -s "$(which nologin)" \
+                        -c "Guix build user $i" --system    \
+                        "guixbuilder${i}"
+                _msg "${PAS}user added <guixbuilder${i}>"
+            elif command -v adduser &>/dev/null; then
+                adduser -G guixbuild -h /var/empty -s "$(which nologin)" \
+                        -H -S "guixbuilder${i}"
+                _msg "${PAS}user added <guixbuilder${i}>"
+            else
+                _msg "${ERR}cannot add user: <guixbuilder${i}>"
+                exit 1
+            fi
         fi
     done
 }
@@ -509,6 +535,7 @@ main()
         TARBALL="$(realpath $1)"
     fi
     sys_create_store "${TARBALL}" "${tmp_path}"
+    sys_create_build_group
     sys_create_build_user
     sys_enable_guix_daemon
     sys_make_guix_available
-- 
2.26.2





  parent reply	other threads:[~2020-05-17 17:19 UTC|newest]

Thread overview: 64+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-04-13 16:04 [bug#40601] [PATCH 0/5] Handle runit-based foreign distributions Vincent Legoll
2020-04-13 16:07 ` [bug#40601] [PATCH 1/5] nix/local.mk: Add missing comment to sysvinit section Vincent Legoll
2020-04-13 16:07   ` [bug#40601] [PATCH 2/5] guix-install.sh: Add xz to requirements Vincent Legoll
2020-04-13 16:07   ` [bug#40601] [PATCH 3/5] guix-install.sh: Fix systemctl not found error message at probe Vincent Legoll
2020-04-13 16:07   ` [bug#40601] [PATCH 4/5] guix-install.sh: Handle local binary tarball file Vincent Legoll
2020-04-13 16:07   ` [bug#40601] [PATCH 5/5] guix-install.sh, guix-binary tarball: Handle runit-based foreign distributions Vincent Legoll
2020-04-23 11:55 ` [bug#40601] bug#39023: binary installation manual doesn't work on Alpine Linux Vincent Legoll
2020-05-17 17:15 ` [bug#40601] [RFC, PATCH 0/28] guix-install.sh: port to other distros & init systems Vincent Legoll
2020-05-17 19:26   ` Julien Lepiller
2020-05-17 19:37     ` Vincent Legoll
2020-05-17 17:16 ` [bug#40601] [PATCH 01/28] nix/local.mk: Add missing comment to sysvinit section Vincent Legoll
2020-05-17 17:16   ` [bug#40601] [PATCH 02/28] guix-install.sh: Add xz to requirements Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 03/28] guix-install.sh: Fix systemctl not found error message at probe Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 04/28] guix-install.sh: Handle local binary tarball file Vincent Legoll
2020-05-23 13:42     ` Tobias Geerinckx-Rice via Guix-patches via
2020-05-23 21:37       ` Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 05/28] guix-install.sh, guix-binary tarball: Handle runit-based foreign distributions Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 06/28] guix-install.sh: trivial whitespace fix Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 07/28] guix-install.sh: Move code in a new function Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 08/28] guix-install.sh: Use getent for both user & group presence checking Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 09/28] guix-install.sh: Fix requirements Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 10/28] guix-install.sh: Replace subshell-inducing command grouping Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 11/28] guix-install.sh: Use a variable for GPG key URL Vincent Legoll
2020-05-17 17:17   ` Vincent Legoll [this message]
2020-05-17 17:17   ` [bug#40601] [PATCH 13/28] guix-install.sh: Make grep & mktemp usage compatible with busybox Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 14/28] guix-install.sh: Make tar " Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 15/28] guix-install.sh, guix-binary tarball: Handle openrc-based foreign distributions Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 16/28] non-interactive mode, usage Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 17/28] fix variable quoting in sys_make_guix_available Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 18/28] Replace the use of "which" by "command -v" Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 19/28] Remove &> and >& bashisms Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 20/28] Add missing variable quoting & curly-bracketing for dl_path Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 21/28] Remove unused variable Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 22/28] Remove local bashisms Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 23/28] Remove $UID bashism Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 24/28] Remove some "[[" bashisms Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 25/28] Remove unused variable set by "read" Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 26/28] Add _debug_func() helper function Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 27/28] Fix variable use in guix_get_bin_list() Vincent Legoll
2020-05-17 17:17   ` [bug#40601] [PATCH 28/28] Remove "[[" bashisms in chk_init_sys() Vincent Legoll
2020-05-23 12:36   ` [bug#40601] [PATCH 01/28] nix/local.mk: Add missing comment to sysvinit section Tobias Geerinckx-Rice via Guix-patches via
2020-05-22 13:44 ` [bug#40601] [guix-daemon now working on parabola with openrc] jgart--- via Guix-patches via
2020-05-22 18:40   ` Leo Famulari
2020-05-31 20:41 ` [bug#40601] New reduced patchset, the easy bits first Vincent Legoll
2020-12-18 12:28   ` Christopher Baines
2020-12-18 19:35     ` Vincent Legoll
2020-12-20 17:30       ` Vincent Legoll
2020-05-31 20:42 ` [bug#40601] [PATCH 1/7] guix-install.sh: Remove "[[" bashisms in chk_init_sys() Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 2/7] guix-install.sh: Remove $UID bashism Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 3/7] guix-install.sh: Fix requirements Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 4/7] guix-install.sh: trivial whitespace fix Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 5/7] guix-install.sh: Add variable quoting in sys_make_guix_available Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 6/7] guix-install.sh: Fix variable uses in guix_get_bin_list() Vincent Legoll
2020-05-31 20:42   ` [bug#40601] [PATCH 7/7] guix-install.sh: Add missing variable quoting & curly-bracketing in guix_get_bin() Vincent Legoll
2020-12-18 11:37     ` Christopher Baines
2020-10-07 16:09 ` [bug#40601] [PATCH 0/5] Handle runit-based foreign distributions zimoun
2020-12-20 17:28 ` [bug#40601] [PATCH 1/5] guix-install.sh: Remove "[[" bashisms in chk_init_sys() Vincent Legoll
2020-12-20 17:28   ` [bug#40601] [PATCH 2/5] guix-install.sh: Remove $UID bashism Vincent Legoll
2020-12-23 12:17     ` Christopher Baines
2020-12-23 14:59       ` Vincent Legoll
2020-12-20 17:28   ` [bug#40601] [PATCH 3/5] guix-install.sh: Fix requirements Vincent Legoll
2020-12-20 17:28   ` [bug#40601] [PATCH 4/5] guix-install.sh: Fix detection of SysV init system Vincent Legoll
2020-12-20 17:28   ` [bug#40601] [PATCH 5/5] guix-install.sh: Check daemonize package presence for sysv-init Vincent Legoll
2021-09-02 17:51 ` [bug#40601] guix-daemon runit service on void jgart via Guix-patches via

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://guix.gnu.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20200517171725.732-12-vincent.legoll@gmail.com \
    --to=vincent.legoll@gmail.com \
    --cc=40601@debbugs.gnu.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://git.savannah.gnu.org/cgit/guix.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).